/*
 * Copyright (C) 1994
 *
 * Department of Computing Science,
 * The University,
 * Newcastle upon Tyne,
 * UK.
 */

#if defined(NO_INLINES) && !defined(DEBUG_CC_)

extern Dbg_std::ostream& operator<< (Dbg_std::ostream&, FacilityCode);
extern Dbg_std::ostream& operator<< (Dbg_std::ostream&, DebugLevel);
extern Dbg_std::ostream& operator<< (Dbg_std::ostream&, VisibilityLevel);

#else

#ifndef NO_INLINES
#  define INLINEF inline
#else
#  define INLINEF
#endif

INLINEF Dbg_std::ostream& DebugController::stream ()
{
    return *dbg_stream;
}

INLINEF int Dbg_std::ostream::fac () const
{
    return dbgFac;
}

INLINEF int Dbg_std::ostream::lvl () const
{
    return dbgLevel;
}

INLINEF int Dbg_std::ostream::vis () const
{
    return dbgVis;
}

INLINEF Dbg_std::ostream& operator<<  ( Dbg_std::ostream& strm, FacilityCode fac )
{
    strm.set_fac(fac);
    return strm;
}

INLINEF Dbg_std::ostream& operator<<  ( Dbg_std::ostream& strm, DebugLevel lvl )
{
    strm.set_lvl(lvl);
    return strm;
}

INLINEF Dbg_std::ostream& operator<<  ( Dbg_std::ostream& strm,  VisibilityLevel vis )
{
    strm.set_vis(vis);
    return strm;
}

#ifdef INLINEF
#  undef INLINEF
#endif

#endif
