/***************************************************************************
    Copyright            : (C) 2003 by David Ang
    Email                : davidang@info.com.ph
	Description          : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#pragma once

#include <windows.h>
#include <d3dx9math.h>

template <class T> 
class CMinMax
{
public:
	CMinMax() {  }
	CMinMax(T min, T max) { m_Min = min; m_Max = max; }
	~CMinMax() { }

	T GetRandomNumber()
	{
		return RandomNumber(m_Min, m_Max);
	}

	float RandomNumber(float fMin, float fMax)
	{
		if(fMax <= fMin) 
			return(fMax);
		float fRandom = (float)rand() / (float)RAND_MAX;
		return((fRandom * (float)fabs(fMax-fMin))+fMin);
	}	

	int RandomNumber(int iMin, int iMax)
	{
		if (iMax <= iMin) return(iMax);
		return((rand() % (abs(iMax-iMin)+1))+iMin);
	}

	DWORD RandomNumber(DWORD iMin, DWORD iMax)
	{
		if (iMax <= iMin) return(iMax);
		return((rand() % (abs(iMax-iMin)+1))+iMin);
	}

	D3DXVECTOR3 RandomNumber(D3DXVECTOR3 vMin, D3DXVECTOR3 vMax)
	{
		float x = RandomNumber(vMin.x, vMax.x);
		float y = RandomNumber(vMin.y, vMax.y);
		float z = RandomNumber(vMin.z, vMax.z);
		return(D3DXVECTOR3(x,y,z));
	}

	D3DXCOLOR RandomNumber(D3DXCOLOR Min, D3DXCOLOR Max)
	{
		float r = RandomNumber(Min.r, Max.r);
		float g = RandomNumber(Min.g, Max.g);
		float b = RandomNumber(Min.b, Max.b);
		float a = RandomNumber(Min.a, Max.a);
		return(D3DXCOLOR(r,g,b,a));
	}

	T m_Min;
	T m_Max;
};
